this.name					= "vortex_player.js";
this.author					= "Thargoid";
this.copyright				= "Creative Commons: attribution, non-commercial, sharealike with clauses - see readme.txt";
this.description			= "Ship script for the Vortex player ship";
this.version				= "1.30";


// General, start and GUI

this.startUp = function()
	{
	if(player.ship.name !== "Vortex") { return; }
	if(player.ship.equipmentStatus("EQ_VORTEX_TURRET") !== "EQUIPMENT_OK") 
		{ player.ship.awardEquipment("EQ_VORTEX_TURRET");}
	log(this.name, "Vortex Player Script Initialised");
	if(missionVariables.multiBay_turret === undefined) { missionVariables.multiBay_turret = "active"; }
	if(missionVariables.multiBay_currentMissile === undefined) { missionVariables.multiBay_currentMissile = 0; }
	if(missionVariables.multiBay_missileBay0 === undefined) { missionVariables.multiBay_missileBay0 = ""; }
	if(missionVariables.multiBay_missileBay1 === undefined) { missionVariables.multiBay_missileBay1 = ""; }
	if(missionVariables.multiBay_missileBay2 === undefined) { missionVariables.multiBay_missileBay2 = ""; }
	if(missionVariables.multiBay_missileBay3 === undefined) { missionVariables.multiBay_missileBay3 = ""; }
	if(missionVariables.multiBay_missileBay4 === undefined) { missionVariables.multiBay_missileBay4 = ""; }
	
	if(missionVariables.multiBay_currentCargo === undefined) { missionVariables.multiBay_currentCargo = 0; }
	if(missionVariables.multiBay_cargoBay0 === undefined) { missionVariables.multiBay_cargoBay0 = "0:0:0:0:0:0:0:0:0:0:0:0:0:0"; }
	if(missionVariables.multiBay_cargoBay1 === undefined) { missionVariables.multiBay_cargoBay1 = "0:0:0:0:0:0:0:0:0:0:0:0:0:0"; }
	if(missionVariables.multiBay_cargoBay2 === undefined) { missionVariables.multiBay_cargoBay2 = "0:0:0:0:0:0:0:0:0:0:0:0:0:0"; }
	if(missionVariables.multiBay_cargoBay3 === undefined) { missionVariables.multiBay_cargoBay3 = "0:0:0:0:0:0:0:0:0:0:0:0:0:0"; }
	if(missionVariables.multiBay_cargoBay4 === undefined) { missionVariables.multiBay_cargoBay4 = "0:0:0:0:0:0:0:0:0:0:0:0:0:0"; }
	
	this.fillWidth = defaultFont.measureString("\037"); // the width of the pad character in ems (full screen = 32em)

	this.cargoNameArray = ["food", "textiles", "radioactives", "slaves", "liquor/wines", "luxuries", "narcotics", "computers", "machinery", "alloys", "firearms", "furs", "minerals", "alien items"];
	this.displayCargoNameArray = ["Food", "Textiles", "Radioactives", "Slaves", "Liquor/Wines", "Luxuries", "Narcotics", "Computers", "Machinery", "Alloys", "Firearms", "Furs", "Minerals", "Alien Items"];
	this.incompatibleEquipment = ["EQ_PASSENGER_BERTH","EQ_REPAIRBOTS_CONTROLLER", "EQ_HYPERCARGO", "EQ_MIL_INJECTION", "EQ_APRIL", "EQ_UNI_TURRET"];
	this.oldTarget = "NONE";
	this.injectorsActive = "NO";
	this.setStationInterface();
	this.ncCheckTimer = new Timer(this, this.ncCheck, 1); // check the existence of cim's New Cargoes OXP - 1s delay to ensure scripts are loaded if present.
	}

this.ncCheck = function()
		{
		this.ncEnabled = false;
		if(worldScripts.CargoTypeExtension) 
			{ // check if New Cargoes OXP is loaded
			this.ncEnabled = true;
			if(missionVariables.multiBay_ncBay0 === undefined) { missionVariables.multiBay_ncBay0 = ""; }
			if(missionVariables.multiBay_ncBay1 === undefined) { missionVariables.multiBay_ncBay1 = ""; }
			if(missionVariables.multiBay_ncBay2 === undefined) { missionVariables.multiBay_ncBay2 = ""; }
			if(missionVariables.multiBay_ncBay3 === undefined) { missionVariables.multiBay_ncBay3 = ""; }
			if(missionVariables.multiBay_ncBay4 === undefined) { missionVariables.multiBay_ncBay4 = ""; }
			}
		}	
	
this.resetVortex = function()
	{
	let resetCounter = 0;
	for(resetCounter = 0;resetCounter<5;resetCounter++)
		{
		missionVariables["multiBay_missileBay" + resetCounter] = "";
		missionVariables["multiBay_cargoBay" + resetCounter] = "0:0:0:0:0:0:0:0:0:0:0:0:0:0";
		}
	missionVariables.multiBay_currentMissile = 0;
	missionVariables.multiBay_currentCargo = 0;
	this.ncCheck();
	}
	
this.playerBoughtNewShip = function(ship)
	{
	this.stopMissileTimer();
	this.resetVortex();

	if(player.ship.name === "Vortex")
		{// if we just bought a Vortex
		this.name1 = ["Heart", "Soul", "Mind", "Keeper", "Seeker", "Bringer", "Master", "Spirit", "Power", "Shadow", "Reflection", "Glory", "Legion"];
		this.name2 = ["Darkness", "Light", "Fire", "Conflict", "War", "Fortune", "Ice", "Battle", "Midnight"];
		this.random1 = (Math.floor((Math.random() * this.name1.length) - 0.000000001));
		this.random2 = (Math.floor((Math.random() * this.name2.length) - 0.000000001));
		if(this.random1 < 0 || this.random1 > (this.name1.length - 1)) { this.random1 = 0; }
		if(this.random2 < 0 || this.random2 > (this.name2.length - 1)) { this.random2 = 0; }
		this.shipTitle = this.name1[this.random1] + " of " + this.name2[this.random2];
		missionVariables.multiBay_storeShipName = this.shipTitle;
		
		this.storeMissileBay(missionVariables.multiBay_currentMissile);
		this.startUp();
		mission.runScreen({title:"Ship Specifications (Vortex)", model:"vortex_player"});
		this.AIName = "MAC" + Math.floor(Math.random() * 10) + Math.floor(Math.random() * 10) + Math.floor(Math.random() * 10) + Math.floor(Math.random() * 10);
		mission.addMessageText("Designation: Vortex - " + this.shipTitle);
		mission.addMessageText("MAC registration: " + this.AIName + "\n");
		this.addEdgeText("Shipyard: Aquarian Shipbuilding Corporation","Special Capabilities:");
		this.addEdgeText("Source: Ex-Military (blockade runner)","Military grade AI");
		this.addEdgeText("Max speed: 450","Damage auto-repair");
		this.addEdgeText("Cargo capacity: 5x 30t","Missile defense screen");
		this.addEdgeText("Missile capacity: 5x 5 pylons","Regenerative fuel injection");
		this.addEdgeText("Energy: 8 banks","Multi-bay cargo storage");
		this.addEdgeText("Pitch/Roll/Yaw: 1.3/1.5/1.5","Switchable missile bays");
		mission.addMessageText("\n\n\nGreetings Commander " + expandDescription("[commander_name]") + ".\n\nI am " + this.AIName + ", the military AI construct of your new ASC Vortex craft, the " + this.shipTitle + ". Self-diagnostics shows all systems functional and ready - I await your command.");
		mission.addMessageText("\nEnd of Line.");
		}
	}

this.createPadString = function(count)
	{
	var padString = "";
	if(!count || count <= 0) { return padString; }
	var counter = 0 ; // reset the counter
	for(counter = 0;counter < count; counter++)
		{ padString = padString + "\037"; }
	return padString;
	}	

this.addEdgeText = function(leftText, rightText)
	{
	if(rightText === "" ||  rightText === undefined || rightText === null)
		{ 
		if(leftText) { mission.addMessageText(leftText); }
		return;	
		}
		
	this.textWidth = defaultFont.measureString(leftText) + defaultFont.measureString(rightText);
	if(this.textWidth > 32)
		{
		log(this.name, "Text " + leftText + " plus " + rightText + " is too long for a single screen line");
		return;
		}
		
	this.padCount = Math.floor((32 - this.textWidth) / this.fillWidth);	
	this.padString = this.createPadString(this.padCount);
	mission.addMessageText(leftText + this.padString + rightText);
	}
	
this.turretToggle = function()
	{
	if(missionVariables.multiBay_turret === "active") 
		{ 
		player.ship.restoreSubEntities(); 
		if(player.ship && player.ship.target && player.ship.target.isValid)
			{
			var subCounter = 0;
			for(subCounter = player.ship.subEntities.length - 1;subCounter>=0;subCounter--)
				{ player.ship.subEntities[subCounter].target = player.ship.target; }	
			}
		}
	else
		{
		var subCounter = 0;
		for(subCounter = player.ship.subEntities.length - 1;subCounter>=0;subCounter--)
			{ player.ship.subEntities[subCounter].remove(); }	
		}
	}
	
this.playerBoughtEquipment = function(equipment)
	{
	if(player.ship.name !== "Vortex") { return; }
	
	if(equipment === "EQ_MULTIBAY_MISSILENEXT")
		{
		player.ship.removeEquipment("EQ_MULTIBAY_MISSILENEXT");
		this.nextMissileBay();
		player.consoleMessage("\n\n\n\n\n\n\n\nMissile Bay - " + (1 + missionVariables.multiBay_currentMissile), 4); 	
		return;
		}
	
	if(this.incompatibleEquipment.indexOf(equipment) != -1)
		{
		mission.runScreen({title:"Incompatible Equipment Detected", exitScreen: "GUI_SCREEN_EQUIP_SHIP"});
		mission.addMessageText("Message from MAC:\n\nUnfortunately Commander " + expandDescription("[commander_name]") + " the " + EquipmentInfo.infoForKey(equipment).name + " that you purchased is incompatible with my systems and cannot be integrated.\n\nI will arrange for it to be returned and for a refund of " + (EquipmentInfo.infoForKey(equipment).price / 10) + "₢ to be made into your account.\n\nEnd of Line.");
		player.ship.removeEquipment(equipment);
		player.credits += EquipmentInfo.infoForKey(equipment).price / 10;
		return;
		}
		
	if(EquipmentInfo.infoForKey(equipment).requiredCargoSpace > 0)
		{
		mission.runScreen({title:"Incompatible Equipment Detected"});
		mission.addMessageText("Message from MAC:\n\nUnfortunately Commander " + expandDescription("[commander_name]") + " the " + EquipmentInfo.infoForKey(equipment).name + " that you purchased is incompatible with my virtual cargo storage systems and cannot be integrated.\n\nI will arrange for it to be returned and for a refund of " + (EquipmentInfo.infoForKey(equipment).price / 10) + "₢ to be made into your account.\n\nEnd of Line.");
		player.ship.removeEquipment(equipment);
		player.credits += EquipmentInfo.infoForKey(equipment).price / 10;
		return;
		}	
	}	

this.equipmentDamaged = function(equipment)
	{ 
	if(equipment === "EQ_MULTIBAY") { player.ship.setEquipmentStatus("EQ_MULTIBAY", "EQUIPMENT_OK"); }
		
	if(player.ship.name !== "Vortex") { return; }
	
	if(player.ship.docked) { return; }
	
	if(!this.damageControlTimer || !this.damageControlTimer.isRunning)
		{
		var repairTime = 60 + Math.ceil(Math.random() * 180);
		player.consoleMessage("MAC - Regeneration in progress", 6);
		this.damageControlTimer = new Timer(this, this.repairSystems, repairTime);	
		}
	}
	
this.shipLaunchedFromStation = function(station)
	{
	if(player.ship.name !== "Vortex") { return; }
	
	this.turretToggle(); // remove turrets if they are de-activated (having been restored on docking to avoid overhaul offer)
	this.startFuelTimer();
	this.startMissileTimer();
	this.repairCheck();
	}

this.setStationInterface = function()
	{
	player.ship.dockedStation.setInterface("vortex_cargo", { title: "Cargo manifest", category: "Ship", summary: "Displays the ships cargo bay manifest.", callback: this.displayCargo.bind(this) });
	player.ship.dockedStation.setInterface("vortex_missile", { title: "Missile bays", category: "Ship", summary: "Displays the ships missile bays.", callback: this.displayMissile.bind(this) });
	}
	
this.shipWillDockWithStation = function(station)
	{
	if(player.ship.name !== "Vortex") { return; }
	
	this.setStationInterface();
	player.ship.restoreSubEntities(); // if the turrets are not on the ship on docking, a maintenance overhaul is offered to restore them!
	this.stopFuelTimer();
	this.stopMissileTimer();
	this.storeCargo(missionVariables.multiBay_currentCargo);
	
	if(this.damageControlTimer && this.damageControlTimer.isRunning)
		{
		this.damageControlTimer.stop();
		}
		
	player.ship.awardEquipment("EQ_RENOVATION");
	player.ship.removeEquipment("EQ_RENOVATION"); //  as it's a self-repairing ship, should never need a maintenance overhaul...
	}	
	
this.guiScreenChanged = function(to, from)
	{
	if(player.ship.name !== "Vortex") { return; }
	
	if(from == "GUI_SCREEN_MARKET") 
		{ 
		this.storeCargo(missionVariables.multiBay_currentCargo); 
		player.consoleMessage(" \n \n \n \n \n \n \n \n", 1); // remove the current bay text if we leave the screen
		}

	if(from == "GUI_SCREEN_EQUIP_SHIP") 
		{ 
		this.storeMissileBay(missionVariables.multiBay_currentMissile); 
		player.consoleMessage(" \n \n \n \n \n \n \n \n", 1); // remove the current bay text if we leave the screen
		}
		
	if(to == "GUI_SCREEN_MARKET")
		{
		if(from == "GUI_SCREEN_MANIFEST")
			{ // access only from manifest to market
			if(player.ship.docked) { this.displayCargo(); }
				else { this.displayMissile(); }	
			}
		else
			{
			if(player.ship.docked)
				{ player.consoleMessage("                                                                                         Current Bay - " + (1 + missionVariables.multiBay_currentCargo), 10); 	}
			}
		}
	}
	
this.choice = function(choice)
	{
	switch(choice)
		{
		case "MULTIBAY_MISSILE_1_LOADED":
			{
			this.nextMissileBayLoaded();
			break;
			}
		case "MULTIBAY_MISSILE_2_NEXT":
			{
			this.storeMissileBay(missionVariables.multiBay_currentMissile);
			missionVariables.multiBay_currentMissile++;
			if(missionVariables.multiBay_currentMissile == 5)
				{missionVariables.multiBay_currentMissile = 0;}
			this.restoreMissileBay(missionVariables.multiBay_currentMissile);
			this.displayMissile();
			break;
			}
		case "MULTIBAY_MISSILE_3_PREVIOUS":
			{
			this.storeMissileBay(missionVariables.multiBay_currentMissile);
			missionVariables.multiBay_currentMissile--;
			if(missionVariables.multiBay_currentMissile == -1)
				{missionVariables.multiBay_currentMissile = 4;}
			this.restoreMissileBay(missionVariables.multiBay_currentMissile);
			this.displayMissile();
			break;
			}
		case "MULTIBAY_MISSILE_4_CARGO":
			{
			this.safeCargo();
			this.displayCargo();
			break;
			}
		case "MULTIBAY_CARGO_1_NEXT":
			{
			this.safeCargo();
			this.storeCargo(missionVariables.multiBay_currentCargo);

			if(this.ncEnabled)
				{ missionVariables["multiBay_ncBay" + missionVariables.multiBay_currentCargo] = worldScripts.CargoTypeExtension.suspendPlayerManifest(); }

			let tempCounter = 0 ; // reset the counter
			for(tempCounter = 0; tempCounter < 14; tempCounter++)
				{
				this.cargoItem = this.cargoNameArray[tempCounter];
				manifest[this.cargoItem] = 0;
				}   
			missionVariables.multiBay_currentCargo++;
			if(missionVariables.multiBay_currentCargo == 5)
				{missionVariables.multiBay_currentCargo = 0;}
			this.restoreCargo(missionVariables.multiBay_currentCargo);

			if(this.ncEnabled && missionVariables["multiBay_ncBay" + missionVariables.multiBay_currentCargo])
				{ 
				worldScripts.CargoTypeExtension.restorePlayerManifest(missionVariables["multiBay_ncBay" + missionVariables.multiBay_currentCargo]); 
				missionVariables["multiBay_ncBay" + missionVariables.multiBay_currentCargo]	= null;
				}

			this.displayCargo();
			break;
			}
		case "MULTIBAY_CARGO_2_PREVIOUS":
			{			
			this.safeCargo();
			this.storeCargo(missionVariables.multiBay_currentCargo);

			if(this.ncEnabled)
				{ missionVariables["multiBay_ncBay" + missionVariables.multiBay_currentCargo] = worldScripts.CargoTypeExtension.suspendPlayerManifest(); }
				
			let tempCounter = 0 ; // reset the counter
			for(tempCounter = 0; tempCounter < 14; tempCounter++)
				{
				this.cargoItem = this.cargoNameArray[tempCounter];
				manifest[this.cargoItem] = 0;
				}  
			missionVariables.multiBay_currentCargo--;
			if(missionVariables.multiBay_currentCargo == -1)
				{missionVariables.multiBay_currentCargo = 4;}
			this.restoreCargo(missionVariables.multiBay_currentCargo);

			if(this.ncEnabled && missionVariables["multiBay_ncBay" + missionVariables.multiBay_currentCargo])
				{ 
				worldScripts.CargoTypeExtension.restorePlayerManifest(missionVariables["multiBay_ncBay" + missionVariables.multiBay_currentCargo]);
				missionVariables["multiBay_ncBay" + missionVariables.multiBay_currentCargo]	= null;			
				}

			this.displayCargo();
			break;
			}
		case "MULTIBAY_CARGO_3_MISSILE":
			{
			this.displayMissile();
			break;
			}
		case "MULTIBAY_MISSILE_5_EXIT":
		case "MULTIBAY_CARGO_4_EXIT":
			{
			break;
			}			
		}
	}
	
this.validateBay = function(bay)
	{
	switch(bay)
		{
		case -1:
			{
			this.return = 4;
			break;
			}
		case 5:
			{
			this.return = 0;
			break;
			}
		default:
			{
			this.return = bay;
			break;
			}
		}
	return this.return;	
	}
	
this.playerWillSaveGame = function(type)
	{ 
	if(player.ship.name !== "Vortex") { return; }
	this.storeMissileBay(missionVariables.multiBay_currentMissile);
	this.storeCargo(missionVariables.multiBay_currentCargo);
	}
	
// Missile Bays	
	
this.displayMissile = function()
	{
	missionVariables.multiBay_previousBay = 1 + this.validateBay(missionVariables.multiBay_currentMissile - 1);
	missionVariables.multiBay_nextBay = 1 + this.validateBay(missionVariables.multiBay_currentMissile + 1);
	mission.runScreen({title:"Missile Bays", choicesKey:"multiBay_missileChoice"}, this.choice);
	mission.addMessageText("Currently you have missile bay " + (missionVariables.multiBay_currentMissile + 1) + " selected.\n");

	let pylonCounter = 0 ; // reset the counter
	for(pylonCounter = 0;pylonCounter<player.ship.missileCapacity;pylonCounter++)
		{
		if(pylonCounter < player.ship.missiles.length)
			{ this.pylonName = player.ship.missiles[pylonCounter].name; }
		else
			{ this.pylonName = "Empty"; }
		mission.addMessageText((1 + pylonCounter) + " - " + this.pylonName);
		}
	
	mission.addMessageText("");	
	this.addMissileBayList();	
	}
	
this.addMissileBayList = function()
	{
	let listCounter = 0 ; // reset the counter
	for(listCounter = 0;listCounter<5;listCounter++)
		{
		if(missionVariables["multiBay_missileBay" + listCounter].length > 0)
			{
			this.tempArray = missionVariables["multiBay_missileBay" + listCounter].split(":");
			this.bayLoad = this.tempArray.length;
			}
		else
			{this.bayLoad = 0; }
		this.messageText = "Missile Bay " + (listCounter + 1) + " - " + this.bayLoad + " / " + player.ship.missileCapacity;
		mission.addMessageText(this.messageText);
		}
	}
	
this.nextMissileBay = function()
	{
	this.storeMissileBay(missionVariables.multiBay_currentMissile);
	missionVariables.multiBay_currentMissile++;
	missionVariables.multiBay_currentMissile = missionVariables.multiBay_currentMissile % 5;
	this.restoreMissileBay(missionVariables.multiBay_currentMissile);
	}
	
this.nextMissileBayLoaded = function()
	{	
	this.storeMissileBay(missionVariables.multiBay_currentMissile);
	this.oldMissileBay = missionVariables.multiBay_currentMissile;
	let nextMissileBayCounter = 1	
	for(nextMissileBayCounter = 1;nextMissileBayCounter<5;nextMissileBayCounter++)
		{
		this.missileBayNumber = (missionVariables.multiBay_currentMissile + nextMissileBayCounter) % 5;
		if(missionVariables["multiBay_missileBay" + this.missileBayNumber] != "")
			{
			missionVariables.multiBay_currentMissile = this.missileBayNumber;
			break;
			}
		}
	if(this.oldMissileBay == missionVariables.multiBay_currentMissile)
		{
		if(player.ship.missiles.length == 0)
			{
			if(!player.ship.docked) { player.consoleMessage("MAC - Missile bays empty.",2); }
			missionVariables.multiBay_currentMissile = 0;
			this.stopMissileTimer();
			}
		else
			{
			if(!player.ship.docked) { player.consoleMessage("MAC - No other bays are loaded.",2); }
			if(this.missileWatchTimer && !this.missileWatchTimer.isRunning)
				{ this.startMissileTimer(); }
			}
		}
	else
		{
		if(!player.ship.docked) { player.consoleMessage("MAC - Missile bay " + (missionVariables.multiBay_currentMissile + 1) + " selected.",2); }
		if(this.missileWatchTimer && !this.missileWatchTimer.isRunning)
			{ this.startMissileTimer(); }
		this.restoreMissileBay(missionVariables.multiBay_currentMissile);
		}
	}
	
this.storeMissileBay = function(bay)
	{
	if(bay.isNan || bay < 0 || bay > 4 || bay != Math.floor(bay))
		{
		log(this.name, "storeMissileBay called with illegal parameter.");
		return;
		}	
	this.storeMissileBayList = "";
	if(player.ship.missiles.length > 0)
		{
		let storeCounter = 0;
		for(storeCounter = 0;storeCounter<player.ship.missiles.length;storeCounter++)
			{
			this.storeMissileBayList = this.storeMissileBayList + player.ship.missiles[storeCounter].equipmentKey + ":";
			}
		this.storeMissileBayList = this.storeMissileBayList.slice(0,-1);	
		}	
	missionVariables["multiBay_missileBay" + bay] = this.storeMissileBayList;

	}
	
this.restoreMissileBay = function(bay)	
	{
	if(bay.isNan || bay < 0 || bay > 4 || bay != Math.floor(bay))
		{
		log(this.name, "restoreMissileBay called with illegal parameter.");
		return;
		}		
	this.restoreMissileBayList = missionVariables["multiBay_missileBay" + bay];
	player.ship.awardEquipment("EQ_MISSILE_REMOVAL");	
	if(this.restoreMissileBayList.length > 0)
		{
		this.restoreMissileBayArray = this.restoreMissileBayList.split(":");
		let restoreCounter = 0;
		for(restoreCounter = 0;restoreCounter<this.restoreMissileBayArray.length;restoreCounter++)
			{ player.ship.awardEquipment(this.restoreMissileBayArray[restoreCounter]); }
		}
	}
	
this.startMissileTimer = function()
	{
	if(player.ship.docked)
		{ return; }
	if(this.missileWatchTimer)
		{ this.missileWatchTimer.start(); }
	else
		{ this.missileWatchTimer = new Timer(this, this.checkMissileBays,0,1); }
	}

this.stopMissileTimer = function()
	{ 
	if(this.missileWatchTimer && this.missileWatchTimer.isRunning) { this.missileWatchTimer.stop(); } 
	}

this.checkMissileBays = function()
	{
	if(!player.ship || !player.ship.isValid)
		{
		this.stopMissileTimer();
		this.resetVortex();
		return;
		}
		
	if(player.ship.missiles.length == 0) { this.nextMissileBayLoaded(); }
	}

this.shipFiredMissile = function(missile, target)
	{
	if(player.ship.name !== "Vortex") { return; }
	
	if(this.missileWatchTimer && !this.missileWatchTimer.isRunning) { this.startMissileTimer(); }
	}

// Cargo bay functions	

this.displayCargo = function()
	{
	this.indent = 4;
	this.storeCargo(missionVariables.multiBay_currentCargo);
	missionVariables.multiBay_previousBay = 1 + this.validateBay(missionVariables.multiBay_currentCargo - 1);
	missionVariables.multiBay_nextBay = 1 + this.validateBay(missionVariables.multiBay_currentCargo + 1);
	mission.runScreen({title:"Cargo Manifest", choicesKey:"multiBay_cargoChoice"}, this.choice);
	mission.addMessageText(this.createPadString(Math.floor(this.indent / this.fillWidth)) + this.rightPad(6, "Commodity") + this.leftPad(3, "B1") + this.leftPad(3, "B2") + this.leftPad(3, "B3") + this.leftPad(3, "B4") + this.leftPad(3, "B5")); 
	mission.addMessageText(this.createPadString(Math.floor(this.indent / this.fillWidth)) + "---------------------------------------------------------------------------------");
	
	this.tempArray = new Array();
	let displayCargoCounter = 0; // reset the counters
	let cargoItemsCounter = 0;
	
	for(displayCargoCounter = 0;displayCargoCounter<5;displayCargoCounter++)
		{ 
		this.tempArray[displayCargoCounter] = missionVariables["multiBay_cargoBay" + displayCargoCounter].split(":"); 
		}
		
	for(cargoItemsCounter = 0;cargoItemsCounter<14;cargoItemsCounter++) // cycle through the 14 stored categories of cargo
		{ 
		this.cargoLine(this.indent, this.displayCargoNameArray[cargoItemsCounter], this.tempArray[0][cargoItemsCounter], this.tempArray[1][cargoItemsCounter], this.tempArray[2][cargoItemsCounter], this.tempArray[3][cargoItemsCounter], this.tempArray[4][cargoItemsCounter]); 
		}	
		
	delete this.tempArray;	
	}	

this.rightPad = function(span, text)
	{
	return text + this.createPadString(Math.floor((span - defaultFont.measureString(text)) / this.fillWidth));
	}

this.leftPad = function(span, text)
	{
	return this.createPadString(Math.floor((span - defaultFont.measureString(text)) / this.fillWidth)) + text;
	}	
	
this.cargoLine = function(indent, commodity, bay1, bay2, bay3, bay4, bay5)
	{
	var indentString = this.createPadString(Math.floor(indent / this.fillWidth));
	var comString = this.rightPad(6, commodity);
	
	if(bay1<10)
		{ var bay1Char = "0" + bay1.toString(); }
	else
		{ var bay1Char = bay1.toString(); }
	var bay1String = this.leftPad(3, bay1Char);

	if(bay2<10)
		{ var bay2Char = "0" + bay2.toString(); }
	else
		{ var bay2Char = bay2.toString(); }
	var bay2String = this.leftPad(3, bay2Char);
		
	if(bay3<10)
		{ var bay3Char = "0" + bay3.toString(); }
	else
		{ var bay3Char = bay3.toString(); }
	var bay3String = this.leftPad(3, bay3Char);
		
	if(bay4<10)
		{ var bay4Char = "0" + bay4.toString(); }
	else
		{ var bay4Char = bay4.toString(); }
	var bay4String = this.leftPad(3, bay4Char);
		
	if(bay5<10)
		{ var bay5Char = "0" + bay5.toString(); }
	else
		{ var bay5Char = bay5.toString(); }
	var bay5String = this.leftPad(3, bay5Char); 
	
	mission.addMessageText(indentString + comString + bay1String + bay2String + bay3String + bay4String + bay5String);
	}
	
this.shipScoopedOther = this.safeCargo = function()
	{
	this.gold = manifest["gold"];
	this.platinum = manifest["platinum"];
	this.gems = manifest["gemStones"];
	manifest["gold"] = 0;
	manifest["platinum"] = 0;
	manifest["gemStones"] = 0;
	manifest["gold"] = this.gold;
	manifest["platinum"] = this.platinum;
	manifest["gemStones"] = this.gems;
	}
	
this.restoreCargo = function(bay)
	{
	this.tempArray = missionVariables["multiBay_cargoBay" + bay].split(":");
	let cargoCounter = 0 ; // reset the counter
	for(cargoCounter = 0;cargoCounter<14;cargoCounter++)
		{
		this.cargoItem = this.cargoNameArray[cargoCounter];
		manifest[this.cargoItem] = this.tempArray[cargoCounter];	
		}	
	}
	
this.storeCargo = function(bay)
	{
	this.tempArray = [];
	let loadCounter = 0 ; // reset the counter
	for(loadCounter = 0;loadCounter<14;loadCounter++)
		{
		this.cargoItem = this.cargoNameArray[loadCounter];
		this.tempArray[loadCounter] = manifest[this.cargoItem];
		}	
	missionVariables["multiBay_cargoBay" + bay] = this.tempArray.join(":");		
	}
	
// Self repair

this.repairCheck = function()
	{
	this.checkSystems();
	if(this.playerDamagedList.length > 0)
		{
		var repairTime = 60 + Math.ceil(Math.random() * 180);
		player.consoleMessage("MAC - Regeneration restarted", 6);
		this.damageControlTimer = new Timer(this, this.repairSystems, repairTime);	
		}
	}

this.checkSystems = function()	
	{
	this.playerDamagedList = [];
	var repairCounter = 0;
	for(repairCounter = 0;repairCounter<player.ship.equipment.length;repairCounter++)
		{
		var scriptEq = EquipmentInfo.infoForKey(player.ship.equipment[repairCounter].equipmentKey);
		if(	player.ship.equipmentStatus(player.ship.equipment[repairCounter].equipmentKey) == "EQUIPMENT_DAMAGED"
			&& ((scriptEq.scriptInfo.thargoidRepairBotChance === undefined 
			|| isNaN(scriptEq.scriptInfo.thargoidRepairBotChance))
			|| (!isNaN(scriptEq.scriptInfo.thargoidRepairBotChance)
			&& scriptEq.scriptInfo.thargoidRepairBotChance > 0))
			)
			{ this.playerDamagedList.push(player.ship.equipment[repairCounter].equipmentKey); }
		}
	}
	
this.repairSystems = function() 
	{
	this.checkSystems();
	if(this.playerDamagedList.length == 0)
		{
		player.consoleMessage("MAC - Regeneration completed", 5);
		return;
		}
	else
		{
		var damagedEquipment = Math.floor(Math.random() * this.playerDamagedList.length); // pick a random element from the list...
		this.fixedItem = this.playerDamagedList[damagedEquipment]; // ...define the item...
		this.fixedName = EquipmentInfo.infoForKey(this.fixedItem).name; // define it's screen name
		this.fixedTech = EquipmentInfo.infoForKey(this.fixedItem).effectiveTechLevel // tech level of the item

		switch(true) 
			{
			case (EquipmentInfo.infoForKey(this.fixedItem).scriptInfo.thargoidRepairBotChance !== undefined && !isNaN(EquipmentInfo.infoForKey(this.fixedItem).scriptInfo.thargoidRepairBotChance)): 
				{this.fixChance = EquipmentInfo.infoForKey(this.fixedItem).scriptInfo.thargoidRepairBotChance; break;}
			case (this.fixedTech < 9): {this.fixChance = 1; break;}
			case ((this.fixedTech > 8) && (this.fixedTech < 17)): {this.fixChance = 1 - ((this.fixedTech - 8)/10); break;}
			case (this.fixedTech == 99): {this.fixChance = 0.1; break;}
			default: {this.fixChance = 0.2; break;}
			}
		}	
		
	if(Math.random() < this.fixChance)
		{
		this.fixItem();
		}
	else
		{
		var repairTime = 60 + Math.ceil(Math.random() * 180);
		player.consoleMessage("MAC - " + this.fixedName + " regeneration ongoing", 5);
		this.damageControlTimer = new Timer(this, this.repairSystems, repairTime);
		}
	}


this.fixItem = function()
	{
	player.ship.setEquipmentStatus(this.fixedItem,"EQUIPMENT_OK"); // and actually fix the thing!
	player.consoleMessage("MAC - " + this.fixedName + " regenerated", 5)
	switch(this.fixedItem) // specific OXP equipment which need rebooting after fixing, or have other issues.
		{
		case "EQ_FUEL_INJECTION":
			{
			this.startFuelTimer();
			break;
			}
		
		case "EQ_FRAME_FUEL_COLLECTOR":
			{
			if(worldScripts["Fuel Collector"]) { worldScripts["Fuel Collector"].shipLaunchedFromStation(); }
			break;	
			}
			
		case "EQ_FRAME_BOUNTY_SCANNER":			
			{
			if(worldScripts["Bounty Scanner"]) { worldScripts["Bounty Scanner"].shipLaunchedFromStation(); }
			break;
			}
			
		case "EQ_EEU":
			{
			if(worldScripts["Emergency Energy Unit"]) { worldScripts["Emergency Energy Unit"].shipLaunchedFromStation(); }
			break;
			}
			
		case "EQ_ROCKHERMIT_SCANNER": 
			{ if(worldScripts["rockHermit_Locator"]) { worldScripts["rockHermit_Locator"].shipLaunchedFromStation(); }
			break; 
			}
		}
		
	if(this.playerDamagedList.length > 1)	
		{
		var repairTime = 60 + Math.ceil(Math.random() * 180);
		player.consoleMessage("MAC - Further regeneration required, working", 6);
		this.damageControlTimer = new Timer(this, this.repairSystems, repairTime);	
		}
		
	}
	
// Defense System

this.shipAttackedWithMissile = function(missile, whom)
	{
	if(player.ship.name !== "Vortex") { return; }
	
	if(missile.scanClass != "CLASS_MISSILE" || (this.defenseTimer && this.defenseTimer.isRunning) || (whom && whom.isPlayer))
		{ return; }

	if(missile) {this.missileData = missile;}
		else {this.missileData = null;}
	if(whom) {this.whomData = whom;}
		else {this.whomData = null;}
	player.consoleMessage("MAC - Defense screen activated.",2);
	this.defenseTimer = new Timer(this, this.defendMissile, 1, 1);
	}

this.defendMissile = function()
	{
	if(!this.missileData || !this.missileData.isValid)
		{
		this.defenseTimer.stop();
		delete this.defenseTimer;
		this.missileData = null;
		this.whomData = null;
		this.missileScan();
		return;
		}
	
	if(player.ship.position.distanceTo(this.missileData.position) < 5000)
		{
		if(player.ship.target && this.oldTarget == "NONE") { this.oldTarget = player.ship.target; }
		player.ship.target = this.missileData;	
		}
			
	if(player.ship.position.distanceTo(this.missileData.position) < 2500)
		{ // if missile is within 2.5km or so, try ECM'ing it too.
		player.ship.fireECM;		
		if(!this.missileData || !this.missileData.isValid)
			{
			this.defenseTimer.stop();
			delete this.defenseTimer;
			this.missileData = null;
			this.whomData = null;
			this.missileScan();
			return;
			}
		}
		
	this.defenseChance = Math.random();
	if(this.defenseChance > 0.25 || !this.missileData)
		{
		return;
		}

	if(this.defenseChance < 0.05 && this.whomData && this.whomData.isValid)
		{
		this.missileData.target = this.whomData;
		return;
		}
	else
		{
		this.missileData.target = null;
		this.missileData.reactToAIMessage("TARGET_LOST");
		return;
		}
	}

this.missileScan = function()
	{
	function incomingMissiles(entity) {return entity.isMissile && entity.target && entity.target.isPlayer}; 
	let targetMissiles = system.filteredEntities(this, incomingMissiles, player.ship, 25600); 
	if(targetMissiles.length > 0 && !this.defenseTimer)
		{	
		this.missileData = targetMissiles[0];
		player.ship.target = targetMissiles[0];
		this.whomData = null;
		this.defenseTimer = new Timer(this, this.defendMissile, 1, 1);
		}
	else
		{ 
		player.consoleMessage("MAC - Defense screen deactivated.",2); 
		if(this.oldTarget && this.oldTarget != "NONE" && this.oldTarget.isValid && (player.ship.position.distanceTo(this.oldTarget.position) < 25600) && !player.ship.target)
			{ player.ship.target = this.oldTarget; }
		this.oldTarget = "NONE";
		}
	}
	
this.shipBeingAttacked = function(whom)
	{
	if(player.ship.name !== "Vortex") { return; }
	
	if(Math.random() < 0.25 && whom && whom.target && whom.target.isPlayer)
		{
		whom.target = null;
		whom.reactToAIMessage("TARGET_LOST");
		}
	
	if(player.ship.energy < 33 && player.ship.fuel > 0)
		{
		this.xDistance = ((Math.random() * 2) - 1) * 1024000;
		this.yDistance = ((Math.random() * 2) - 1) * 1024000;
		this.zDistance = ((Math.random() * 2) - 1) * 1024000;	
		this.newPosition = player.ship.position.add([this.xDistance, this.yDistance, this.zDistance]);
		
		let probe = player.ship.spawnOne('splinter');
		probe.position = this.newPosition;
		if(probe && probe.isValid)
			{
			probe.remove();
			player.ship.position = this.newPosition;
			player.ship.fuel -= 0.1;
			player.consoleMessage("MAC - Emergency displacement activated.",8);
			}
		}	
	}

// Military grade fuel injection	

this.shipWillLaunchFromStation = this.shipWillExitWitchspace = function()
	{ this.injectorsActive = "NO"; }
		
this.startFuelTimer = function()
	{
	this.fuelFlag = 0;
	if(this.fuelWatchTimer)
		{ this.fuelWatchTimer.start(); }
	else
		{ this.fuelWatchTimer = new Timer(this, this.checkSpeed,0,1); }
	}

this.shipDied = this.stopFuelTimer = function()
	{
	this.fuelFlag = 0;
	this.injectorsActive = "NO";
	if(this.fuelWatchTimer && this.fuelWatchTimer.isRunning) { this.fuelWatchTimer.stop(); } 
	}
	
this.checkSpeed = function()
	{
	if(player.ship.equipmentStatus("EQ_FUEL_INJECTION") !== "EQUIPMENT_OK") 
		{ 
		this.stopFuelTimer();
		return;
		}
		
	this.normalVelocity = player.ship.vectorForward.multiply(player.ship.maxSpeed);
	
	if(player.ship.speed == 7 * player.ship.maxSpeed) // if the ship is under fuel injection (FI is speed x 7, torus is speed x 32)
		{ //  increment flag, looping between 0 and 9
		this.injectorsActive = "YES";
		this.fuelFlag += 1;
		this.fuelFlag = this.fuelFlag % 8;	
		}
	else
		{
		if(this.injectorsActive === "YES") { player.ship.velocity = this.normalVelocity; }
		this.injectorsActive = "NO";
		return; 
		} // if not under fuel injection, exit function
		
	if(this.fuelFlag == 7) // every 8th second under fuel injection
		{ 
		player.ship.fuel += 0.1;
		if(player.ship.velocity.magnitude < (this.normalVelocity.magnitude * 3))
			{ player.ship.velocity = player.ship.velocity.add(this.normalVelocity.multiply(0.334)); }
		else	
			{ player.ship.velocity = this.normalVelocity.multiply(3); }
		}
	}